﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using Syncfusion.Pdf.Parsing;
using Windows.Foundation;
using Windows.Foundation.Collections;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.Storage.Streams;
using Windows.System;
using Windows.UI.Popups;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Controls.Primitives;
using Windows.UI.Xaml.Data;
using Windows.UI.Xaml.Input;
using Windows.UI.Xaml.Media;
using Windows.UI.Xaml.Navigation;

// The Blank Page item template is documented at http://go.microsoft.com/fwlink/?LinkId=234238

namespace PDFViewerWintRT
{
    /// <summary>
    /// An empty page that can be used on its own or navigated to within a Frame.
    /// </summary>
    public sealed partial class MainPage : Page
    {
        public MainPage()
        {
            this.InitializeComponent();
            this.DataContext = pdfViewer;
        }

        /// <summary>
        /// Invoked when this page is about to be displayed in a Frame.
        /// </summary>
        /// <param name="e">Event data that describes how this page was reached.  The Parameter
        /// property is typically used to configure the page.</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {

        }

        async private void PageLoaded(object sender, RoutedEventArgs e)
        {
            Assembly assembly = typeof(MainPage).GetTypeInfo().Assembly;
            Stream fileStream = assembly.GetManifestResourceStream("PDFViewerWintRT.Assets.Pdf.Barcode.pdf");
            byte[] buffer = new byte[fileStream.Length];
            fileStream.Read(buffer, 0, buffer.Length);
            PdfLoadedDocument ldoc = new PdfLoadedDocument(buffer);
            pdfViewer.LoadDocument(ldoc);
        }


        void pdfViewer_ZoomChanged(object sender, Syncfusion.Windows.PdfViewer.ZoomChangedEventArgs e)
        {

            //CurrentZoom.Text = pdfViewer.Zoom.ToString();
            //throw new NotImplementedException();
        }

        void pdfViewer_PageChanged(object sender, Syncfusion.Windows.PdfViewer.PageChangedEventArgs e)
        {
            
            //PageNumber.Text = pdfViewer.PageNumber.ToString();//
            //throw new NotImplementedException();
            //PageNumber.Text = e.NewPageNumber.ToString();
        }

        async private void BtnOpen_Click_1(object sender, RoutedEventArgs e)
        {
            var picker = new FileOpenPicker();
            picker.SuggestedStartLocation = PickerLocationId.DocumentsLibrary;
            picker.ViewMode = PickerViewMode.List;
            picker.FileTypeFilter.Add(".pdf");
            var file = await picker.PickSingleFileAsync();
            if (file == null) return;
            var stream = await file.OpenAsync(Windows.Storage.FileAccessMode.Read);
            Stream fileStream = stream.AsStreamForRead();
            byte[] buffer = new byte[fileStream.Length];
            fileStream.Read(buffer, 0, buffer.Length);
            PdfLoadedDocument ldoc = new PdfLoadedDocument(buffer);
            pdfViewer.LoadDocument(ldoc);
            pdfViewer.ViewMode = Syncfusion.Windows.PdfViewer.PageViewMode.FitWidth;
            //pdfViewer.ShowPageNumber = true;
        }

        private void GotoPopUpButton_Click(object sender, RoutedEventArgs e)
        {
            ZoomPopUp.IsOpen = false;
            ViewModePopUp.IsOpen = false;
            if (GotoPagePopUp.IsOpen)
            {
                GotoPagePopUp.IsOpen = false;
            }
            else
            {
                GotoPagePopUp.IsOpen = true;
            }
        }

        private void PageDextTxtBox_KeyDown(object sender, KeyRoutedEventArgs e)
        {
            int destPage = 0;
            bool result = int.TryParse(PageDextTxtBox.Text, out destPage);
            if (e.Key == VirtualKey.Enter && result)
            {
                pdfViewer.GotoPage(destPage);
                PageDextTxtBox.Text = string.Empty;
            }
        }

        private void PageDextTxtBox_GotFocus(object sender, RoutedEventArgs e)
        {
            PageDextTxtBox.SelectAll();
        }

        private void ZoomValue_KeyDown(object sender, TappedRoutedEventArgs e)
        {
            int zoomValue = 0;
            bool result = int.TryParse(PageDextTxtBox.Text, out zoomValue);
            if (zoomValue >= 100 || zoomValue <= 300)
            {
                //pdfViewer.Zoom = zoomValue;
                //pdfViewer.ZoomTo(zoomValue);
            }
        }

        private void ClosePopUp(object sender, TappedRoutedEventArgs e)
        {
            GotoPagePopUp.IsOpen = false;
            PageDextTxtBox.Text = string.Empty;
        }

        private void ZoomValue_KeyDown_1(object sender, KeyRoutedEventArgs e)
        {
            int zoomValue = 0;
            bool result = int.TryParse(ZoomValue.Text, out zoomValue);
            if (e.Key == VirtualKey.Enter && result)
                if (zoomValue >= 100 || zoomValue <= 300)
                {
                    //pdfViewer.Zoom = zoomValue;
                    //pdfViewer.ZoomTo(zoomValue);
                }
        }

        private void Zoom_BtnClick(object sender, RoutedEventArgs e)
        {            
            int zoomValue = 0;
            bool result = int.TryParse(ZoomValue.Text, out zoomValue);
            
            if (zoomValue >= 100 || zoomValue <= 300)
            {
                //pdfViewer.Zoom = zoomValue;
                //pdfViewer.ZoomTo(zoomValue);
            }
        }

        private void ZoomPopUp_ButtonClick(object sender, RoutedEventArgs e)
        {
            GotoPagePopUp.IsOpen = false;
            ViewModePopUp.IsOpen = false;
            if (ZoomPopUp.IsOpen)
            {
                ZoomPopUp.IsOpen = false;
            }
            else
            {
                ZoomPopUp.IsOpen = true;
            }
        }

        private void ZoomValue_GotFocus(object sender, RoutedEventArgs e)
        {
            ZoomValue.SelectAll();
        }

        private void ViewModePopUp_ButtonClick(object sender, RoutedEventArgs e)
        {
            ZoomPopUp.IsOpen = false;
            GotoPagePopUp.IsOpen = false;
            if (ViewModePopUp.IsOpen)
            {
                ViewModePopUp.IsOpen = false;
            }
            else
            {
                ViewModePopUp.IsOpen = true;
            }
        }

        private void ViewModeGrid_Loaded(object sender, RoutedEventArgs e)
        {
            if (ViewModeCombo.Items.Count == 0)
            {
                ViewModeCombo.Items.Add(Syncfusion.Windows.PdfViewer.PageViewMode.FitWidth);
                ViewModeCombo.Items.Add(Syncfusion.Windows.PdfViewer.PageViewMode.Normal);
                ViewModeCombo.Items.Add(Syncfusion.Windows.PdfViewer.PageViewMode.OnePage);
            }
        }

        private void ViewModeSelected_Click(object sender, RoutedEventArgs e)
        {
            object selectedItem = ViewModeCombo.SelectedItem;
            if (selectedItem != null)
                pdfViewer.ViewMode = (Syncfusion.Windows.PdfViewer.PageViewMode)selectedItem;
        }
    }
}
